<?php
/*
beroFix.php
*/
include('/usr/fallback/beroConf.php');

include('/usr/local/php/include/fulltrace.Class.php');
include('/usr/local/php/include/confBackup.Class.php');

include('../berogui/misc/database.php');
include('../berogui/includes/isgwtelnet.php');

$Version='2.08';
$cmd = ((isset($_POST['cmd'])) ? $_POST['cmd'] : $_GET['cmd']);
$data = ((isset($_POST['data'])) ? $_POST['data'] : $_GET['data']);

static $display;
unset($display);

switch ($cmd) {
default:
case 'info':
	$tmp = split('=', $data);
	if (count($tmp) != 2) {
		unset($display);
        } else {
		$cinfo = $tmp[1];
        	$display = infocmd($cinfo);
        }
	break;
case 'fulltrace':
	echo fulltrace();
	exit;
case 'getcdr':
	echo getcdr();
	exit;
case 'misdnportinfo':
	echo misdnportinfo();
	exit;
case 'setpassword':
	echo setpassword();
	exit;
case 'setapipwd':
	echo setapipwd();
	exit;
case 'getsipstate':
	echo getsipstate();
	exit;
case 'getisdnstate':
	echo getisdnstate();
	exit;
case 'getanalogstate':
	echo getanalogstate();
	exit;
case 'reload':
	echo reload();
	exit;
case 'restart':
	echo restart();
	exit;
case 'reboot':
	echo reboot();
	exit;
case 'rebootfirmwareupdate':
	echo rebootfirmwareupdate();
	exit;
case 'restoreoldconfig':
	echo restoreoldconfig();
	exit;
case 'setprovtype':
	echo setprovtype();
	exit;
case 'settftp':
	echo settftp();
	exit;
case 'sethttp':
	echo sethttp();
	exit;
case 'config_update':
case 'tftp_config_update':
	echo config_update();
	exit;
case 'firmware_update':
case 'tftp_firmware_update':
	echo firmware_update();
	exit;
case 'firmware_update_form':
	echo firmware_update_form();
	exit;
case 'getlif':
	echo getlif();
	exit;
case 'getinfo':
	echo getinfo();
	exit;
case 'createConfBackup':
	echo createConfBackup();
	exit;
case 'restoreConfBackup':
	echo restoreConfBackup();
	exit;
case 'logging':
	echo logging();
	exit;
case 'berocloud':
	echo berocloud();
	exit;
case 'getisgwinfo':
	echo getisgwinfo();
	exit;
case 'getisdnstats':
	echo getisdnstats();
	exit;
case 'healthcheck':
	echo healthcheck();
	exit;
case 'smslist':
	echo smslist();
	exit;
case 'smsget':
	echo smsget();
	exit;
case 'smssend':
	echo smssend();
	exit;
case 'smssend2':
	echo smssend2();
	exit;
case 'smsdelete':
	echo smsdelete();
	exit;
case 'setdhcp':
	echo setdhcp();
	exit;
case 'setnetwork':
	echo setnetwork();
	exit;
}

// Info-Texts
$command[] = array('name' => 'setpassword', 'head' => 'SetPassword', 'desc' => 'set the beroNet Gateway Password (GUI, API & SSH-Access)');
$command[] = array('name' => 'setprovtype', 'head' => 'SetProvType', 'desc' => 'set the beroNet Gateway provisioning mode to tftp or http');
$command[] = array('name' => 'settftp', 'head' => 'SetTFTP', 'desc' => 'set TFTP server and URL');
$command[] = array('name' => 'sethttp', 'head' => 'SetHTTP', 'desc' => 'set HTTP server and URL');
$command[] = array('name' => 'setdhcp', 'head' => 'SetDHCP', 'desc' => 'set DHCP');
$command[] = array('name' => 'setnetwork', 'head' => 'SetNetwork', 'desc' => 'set the network settings');
$command[] = array('name' => 'getlif', 'head' => 'GetLif', 'desc' => 'get installed LineInterfaces');
$command[] = array('name' => 'getinfo', 'head' => 'GetInfo', 'desc' => 'get information on Hardware-Revison, Firmware-Version, etc.');
$command[] = array('name' => 'getisdnstate', 'head' => 'GetISDNState', 'desc' => 'get the state of each configured ISDN port');
$command[] = array('name' => 'getisdnstats', 'head' => 'GetISDNStats', 'desc' => 'get ISDN Layer 1 / Layer 2 statistics');
$command[] = array('name' => 'getanalogstate', 'head' => 'GetAnalogState', 'desc' => 'get the state of each configured analog port');
$command[] = array('name' => 'getsipstate', 'head' => 'GetSIPState', 'desc' => 'get the state of each SIP Registar');
$command[] = array('name' => 'getisgwinfo', 'head' => 'GetISGWInfo', 'desc' => 'get the several infos from ISGW (Telnet Wrapper)');
$command[] = array('name' => 'logging', 'head' => 'Logging', 'desc' => 'control logging features on the beroNet Gateway');
$command[] = array('name' => 'getcdr', 'head' => 'GetCDR', 'desc' => 'get the CDR');
$command[] = array('name' => 'config_update', 'head' => 'Config_Update', 'desc' => 'start Config Update via TFTP or HTTP depending on how setprovtype is set');
$command[] = array('name' => 'firmware_update', 'head' => 'Firmware_Update', 'desc' => 'start Firmware Update via TFTP or HTTP depending on how setprovtype is set');
$command[] = array('name' => 'firmware_update_form', 'head' => 'Firmware_Update_Form', 'desc' => 'start Firmware update via web form');
$command[] = array('name' => 'berocloud', 'head' => 'beroCloud', 'desc' => 'enable Monitoring for beroNet\'s Cloud solution');
$command[] = array('name' => 'createConfBackup', 'head' => 'CreateConfBackup', 'desc' => 'create and download configuration-backup');
$command[] = array('name' => 'restoreConfBackup', 'head' => 'RestoreConfBackup', 'desc' => 'upload and install configuration-backup');
$command[] = array('name' => 'restoreoldconfig', 'head' => 'RestoreOldConfig', 'desc' => 'restore the previous provisioning config');
$command[] = array('name' => 'fulltrace', 'head' => 'Fulltrace', 'desc' => 'start, stop and download a Fulltrace');
$command[] = array('name' => 'reload', 'head' => 'Reload', 'desc' => 'reload with new settings');
$command[] = array('name' => 'reboot', 'head' => 'Reboot', 'desc' => 'reboot the beroNet Gateway');
$command[] = array('name' => 'rebootfirmwareupdate', 'head' => 'RebootFirmwareUpdate', 'desc' => 'Reboot the beroNet Gateway into Update-Mode');
$command[] = array('name' => 'smslist', 'head' => 'SMSList', 'desc' => 'list SMS Queues');
$command[] = array('name' => 'smsget', 'head' => 'SMSGet', 'desc' => 'get SMS');
$command[] = array('name' => 'smssend', 'head' => 'SMSSend', 'desc' => 'send SMS');
$command[] = array('name' => 'smsdelete', 'head' => 'SMSDelete', 'desc' => 'delete SMS');
$command[] = array('name' => 'healthcheck', 'head' => 'HealthCheck', 'desc' => 'check the health state of the beroNet Gateway');


$bc = new beroConf('root');
if ($bc->get('root', 'api_disable') == '1') {
	header($_SERVER['SERVER_PROTOCOL'] . ' 403 Forbidden');
	exit(0);
}
unset($bc);

// HEADER
echo	'<html>' ."\n" .
	'<head>' . "\n" .
	'<link rel="stylesheet" type="text/css" href="../berogui/includes/template_css.css" />' . "\n" .
	'<link rel="icon" href="../berogui/includes/images/favicon.ico" type="image/x-icon">' . "\n" .
	'<title>API</title>' . "\n" .
	'</head>' . "\n" .
	'<body>' . "\n" .
	'<div class="container" id="page">' . "\n" .
	'<div id="header" style="padding-bottom:15px;">' . "\n" .
        '<div id="logo"><a href="http://www.beronet.com/" target="_blank" onfocus="if (this.blur()) { this.blur(); }">' .
        '<img src="http:../berogui/includes/images/beroNet.jpg" alt="beroNet" class="png" /></a></div>' .
	'<p><font face="Loma,Sans,Arial" size="5" color="#918e8c">Configuration API</font>' .
	'<font face="Loma,Sans,Arial" size="2" color="#918e8c"> v.' . $Version . '</font></p></div>' . "\n";

//Start text
if(!isset($display)) {

	$ret .= '<br /><br />' . "\n" .
		'<table class="contenttoc" width="90%">' . "\n" .
		'<tr><th>Commands</th></tr>' . "\n" .
		'<tr><td style="text-align:left !important;" nowrap>Commands have always the following schema:</td></tr>' . "\n" .
		'<td style="text-align:left !important;" nowrap>beroFix.php?cmd=[command]&data=[key1]=[value1]:[key2]=[value2]...</td></table><br/><br/><br/>' . "\n" .
		'<table class="contenttoc" width="90%"><tr><th colspan="2">Commands Overview</th></tr>' . "\n";

	foreach ($command as $cmd_info) {
		$ret .= '<tr>' . "\n" .
			'<td style="text-align:left !important;"><a href="./beroFix.php?cmd=info&data=info=' . $cmd_info['name'] . '"><b>' . $cmd_info['head'] . '</b></td>' . "\n" .
			'<td nowrap style="text-align:left !important;">Function to ' . $cmd_info['desc'] . '</a></td>' . "\n" .
			'</tr>' . "\n";
	}

	$ret .= '</table><br />' . "\n";
} else {
	$ret = $display;
}

echo $ret;

// FOOTER
echo	'<div id="footer" class="clear">' . "\n" .
	'<div class="part1">Copyright &copy; 2014 beroNet GmbH, Germany</div>' . "\n" .
	'<!-- links -->' . "\n" .
	'<div class="part2"></div>' . "\n" .
	'<!-- footer -->' . "\n" .
	'</div>' . "\n" .
	'</body>' . "\n" .
	'</html>';

// parse the parameters
function _parse_data() {

	global $data;

	if (strpos($data, ':') !== false) {
		foreach (split(':', $data) as $keyval) {
			$tmp = explode('=', $keyval,2);
			$ret[$tmp[0]] = $tmp[1];
			unset($tmp);
		}

		return($ret);
	}

	if (strpos($data, '=') !== false) {
		$tmp = split('=', $data);
		$ret[$tmp[0]] = $tmp[1];

		return($ret);
	}

	return(false);
}

function _getParam($param){
    if (!isset($_POST[$param]) && !isset($_GET[$param])) return null;
    return ((isset($_POST[$param])) ? $_POST[$param] : $_GET[$param]);
}

function misdnportinfo() {

	exec('/usr/local/bin/misdnportinfo', $result);
        $resultstring = "misdnportinfo:\n";
        foreach($result as $row) {
		$resultstring .= $row . "\n";
	}

	return $resultstring;
}

function smslist() {

	$parm = _parse_data();

	if (count($parm) != 1) {
		return('smslist:failed:smslist_requires_1_parameter');
	}

	$smspath = '/tmp/sms/' . $parm['queue'];

	if (($dp = @opendir($smspath)) == null) {
		return('smslist:failed:smslist_queue_not_found');
	}

	while (($file = readdir($dp)) !== false) {
		if (($file == '.') || ($file == '..')) {
			continue;
		}

		if (($queue != 'failout') && preg_match('/.*\.sms$/', $file)) {
			echo basename($file, '.sms') . "\n";
		} elseif($queue == 'failout') {
			echo $file.'\n';
		}
	}

	return('smslist:success');
}

function smsget() {

	$parm = _parse_data();

	if(count($parm) < 2) {
		return('smsget:failed:smsget_requires_at_least_2_parameters');
	}

	$smspath = '/tmp/sms/' . $parm['queuename'];

	if (!file_exists($smspath)) {
		return('smsget:failed:smsget_queue_does_not_exists');
	}

	switch ($parm['queue']) {
	case 'in':
		echo @file_get_contents($smspath . $id . '.sms') . "\n";
		if ($parm['delete'] == 'yes') {
			@unlink($smspath . $id . '.sms');
		}
		break;
	case 'out':
		echo @file_get_contents($smspath . $id . '.sms') . "\n";
		echo @file_get_contents($smspath . $id . '.sms.log') . "\n";
		if ($parm['delete'] == 'yes') {
			@unlink($smspath . $id . '.sms');
			@unlink($smspath . $id . '.sms.log');
		}
		break;
	case 'failout':
		echo @file_get_contents($smspath . $id . '/message')."\n";
		echo @file_get_contents($smspath . $id . '/message.log')."\n";
		if ($parm['delete'] == 'yes') {
			@unlink($smspath . $id . '/message');
			@unlink($smspath . $id . '/message.log');
			@rmdir($smspath . $id);
		}
		break;
	}

	return('smsget:success');
}

function smsdelete() {

	$parm = _parse_data();

	if(count($parm) < 2) {
		return('smsdelete:failed:smsdelete_requires_at_least_2_parameters');
	}

	$smspath = '/tmp/sms/' . $parm['queuename'];

	if (!file_exists($smspath)) {
		return('smsdelete:failed:smsdelete_queue_does_not_exists');
	}

	switch($parm['queue']) {
	case 'in':
		@unlink($smspath . $id . '.sms');
		break;
	case 'out':
		@unlink($smspath . $id . '.sms');
		@unlink($smspath . $id . '.sms.log');
		break;
	case 'failout':
		@unlink($smspath . $id . '/message');
		@unlink($smspath . $id . '/message.log');
		@rmdir($smspath . $id);
		break;
	}

	return('smsdelete:success');
}

function smssend() {

	$parm = _parse_data();

	if(count($parm) < 3) {
		return('smssend:failed:smssend_requires_at_least_3_parameters');
	}

	if (strlen($parm['msg']) > 670) {
		return('smssend:failed:message_too_long');
	}

	$sms_file = '/tmp/sms/out/' . uniqid() . '.sms';

	$content =	'num=' . $parm['num'] . "\n" .
			'port='. $parm['port'] . "\n".
			'msg=' .$parm['msg'];
	file_put_contents($sms_file, $content);

	return('smssend:success');
}

function smssend2() {
    $num=  _getParam('num');
    $port=  _getParam('port');
    $msg=  _getParam('msg');
    if ($num===null || $port===null || $msg===null){
        return('smssend:failed:smssend_requires_at_least_3_parameters');
    }
    if (strlen($msg) > 670) {
	return('smssend:failed:message_too_long');
    }
    $sms_file = '/tmp/sms/out/' . uniqid() . '.sms';

    $content =	'num=' . $num . "\n" .
                'port='. $port . "\n".
                'msg=' .$msg;
    file_put_contents($sms_file, $content);

    return('smssend:success');
}

function getcdr() {

	$parm = _parse_data();

	$ba = new beroAri();

	switch ($parm['log']) {
	case 'yes':
		$ba->set('logcdr', '1');
		return('getcdr:success');
	case 'no':
		$ba->set('logcdr', '0');
		return('getcdr:success');
	}

	switch ($parm['action']) {
	case 'download':
		if ($db->get('logcdr') != '1') {
			return('getcdr:failed:cdrlog must be activated');
		}

		if (!file_exists('/tmp/isgw.cdr.1')) {
			$isgw = new isgwtelnet();
			$isgw->isgw_login();
			$isgw->flush_cdr();
			sleep(4);
		}

		if (!file_exists('/tmp/isgw.cdr.1')) {
			return('getcdr:failed:CDRs are not avaliable');
		}

		copy('/tmp/isgw.cdr.1', '/tmp/isgw.cdr.2');
		$file = file_get_contents('/tmp/isgw.cdr.2');

		header('Content-Type: application/force-download');
		header('Content-Disposition: attachment; filename=isgw.cdr' . "\r\n\r\n");
		header('Content-Length: ' . strlen($file) . "\n\n");
		echo $file;
		unset($file);

		@unlink('/tmp/isgw.cdr.1');
		@unlink('/tmp/isgw.cdr.2');
		return('getcdr:success');
		break;
	case 'delete':
		return('getcdr:delete success');
	}
}

function healthcheck() {

	exec('/usr/bin/uptime', $resup);
	preg_match('/.*load average: (.*),.*,.*/', $resup[0], $load);
	exec('/usr/bin/free', $resup);
	preg_match('/.*Mem:[ ]*[0-9]*[ ]*[0-9]*[ ]*([0-9]*)[ ]*[0.9]*[ ]*[0-9]*[ ]*/', $resup[2], $free_mem);

        $coredump = ((file_exists('/var/log/debug-info.tar.gz')) ? 1 : 0);

	return(' CPU Load: ' . $load[1] . "\n" .' Free RAM: ' . $free_mem[1] . "\n");
}

function fulltrace () {

	$parm = _parse_data();

	$db = new beroAri();
	$ft = new fulltrace();

	switch ($parm['action']) {
	case 'start':
		if ($db->get('trace') == 'yes') {
			return('fulltrace:full_trace_is_already_running');
		}

		$enable = array('isdn' => 1, 'analog' => 1, 'gsm' => 1);
		$enable['sip_sign'] = (($parm['sipsig'] == 'yes') ? 1 : 0);
		$enable['sip_audio'] = (($parm['sipaudio'] == 'yes') ? 1 : 0);

		$res = $db->select('SELECT port FROM isdn;');
		while ($entry = $db->fetch_array($res)) {
			$isdn_ports[] = $entry['port'];
		}
		unset($res);

		$ft->start($enable, $isdn_ports);
		break;
	case 'stop':
		$ft->stop();
		break;
	case 'download':
		if (!file_exists('/var/log/DebugFiles.tar.gz')) {
			return('fulltrace:file_not_found');
		}

		$debug_archive = file_get_contents('/var/log/DebugFiles.tar.gz');
		header('Content-Type: application/force-download');
		header("Content-Disposition: attachment; filename=DebugFiles.tar.gz\r\n\r\n");
		header('Content-Length: ' . strlen($debug_archive) . "\n\n");

		echo $debug_archive;
		break;
	default:
		return('fulltrace:invalid_parameters');
		break;
	}

	return('fulltrace:success');
}

function setapipwd () {

	$parm = _parse_data();

	if (count($parm) != 1) {
		return('setapipwd:failed:setapipwd_requires_1_parameter');
	}

	$ba = new beroAri('/usr/conf/ari.db');
	$bc = new beroConf('root');

	// GUI Password
	require_once('../berogui/includes/password_func.php');
	$ba->update('UPDATE users SET password = \'' . tep_encrypt_password($parm['password']) . '\' WHERE user = \'admin\'');

	// API Password
	@unlink('/usr/conf/apiusers.conf');
	if(($fp = fopen('/usr/conf/apiusers.conf','w')) == null) {
		return('setapipwd:failed:could_not_open_apiusersconf_for_writing');
	}
	fputs($fp, 'admin:'. crypt($parm['password'], base64_encode($parm['password'])) . "\n");
	fclose($fp);

	// SSH Password
	exec('/usr/local/sbin/pwchange.sh admin ' . $parm['password']);

	if ($bc->get('root', 'ssh_admin_enable') != '1') {
		exec('/bin/mount -oremount,rw /; /usr/bin/passwd -l admin; sync; /bin/mount -oremount,ro /');
	}

	return('setapipwd:success');
}

function setpassword () {
	$parm = _parse_data();

	if (count($parm) != 2) {
		return('setpassword:failed:setpassword_requires_2_parameters');
	}

	$ba = new beroAri('/usr/conf/ari.db');
	$bc = new beroConf('root');

	// GUI Password
	$res = $ba->select('SELECT password FROM users WHERE user = \'admin\';');
	$old_pw_enc = $ba->fetch_array($res);
	unset($res);

	require_once('../berogui/includes/password_func.php');
	if (!tep_validate_password($parm['oldpassword'], $old_pw_enc['password'])) {
		return('setpassword:failed:oldpwd_does_not_match');
	}

	$ba->update('UPDATE users SET password = \'' . tep_encrypt_password($parm['newpassword']) . '\' WHERE user = \'admin\'');

	// API Password
	@unlink('/usr/conf/apiusers.conf');
	if(($fp = fopen('/usr/conf/apiusers.conf','w')) == null) {
		return('setpasswd:error:could_not_open_apiusersconf_for_writing');
	}
	fputs($fp, 'admin:'. crypt($parm['newpassword'], base64_encode($parm['newpassword'])) . "\n");
	fclose($fp);

	// SSH Password
	exec('/usr/local/sbin/pwchange.sh admin ' . $parm['newpassword']);

	if ($bc->get('root', 'ssh_admin_enable') != '1') {
		exec('/bin/mount -oremount,rw /; /usr/bin/passwd -l admin; sync; /bin/mount -oremount,ro /');
	}

	return('setpassword:success');
}

function setnetwork() {

	$parm = _parse_data();

	if (count($parm) < 2) {
		return('setnetwork:failed:setnetwork_requires_at_least_2_parameters');
	}

	if (($ip == '') || ($netmask == '')) {
		return('setnetwork:failed:ip_address_and_netmask_are_required');
	}

	$bc = new beroConf('root');
	$bc->set('root', 'lan-dhcp', 'no');
	$bc->set('root', 'lan-ippaddr', sqlite_escape_string($parm['ip']));
	$bc->set('root', 'lan-netmask', sqlite_escape_string($parm['netmask']));
	$bc->set('root', 'lan-gateway', sqlite_escape_string($parm['gateway']));
	$bc->set('root', 'lan-nameserver', sqlite_escape_string($parm['nameserver']));

	return('setnetwork:success');
}

function setdhcp() {
	$bc=new beroConf('root');
	$bc->set('root', 'lan-dhcp', 'yes');
	return('setdhcp:success');
}

function getsipstate() {
	$isgw = new isgwtelnet();

	if (!($result = $isgw->isgw_login())) {
		return('getsipstate:error');
	}

	return('getsipstate:success' . "\n" . $isgw->isgw_sipstate());
}

function getanalogstate() {
	$isgw = new isgwtelnet();

	if (!($result = $isgw->isgw_login())) {
		return('getanalogstate:error');
	}

	return('getanalogstate:success' ."\n" . $isgw->isgw_analogstate());
}

function getisdnstate() {
	$error = 0;
	$isgw = new isgwtelnet();

	if (!($result=$isgw->isgw_login())) {
		return('getisdnstate:error');
	}

	return('getisdnstate:success' ."\n" . $isgw->isgw_isdnstate());
}

function getisdnstats() {

	exec('/bin/cat /proc/l1_stats', $result);
        foreach($result as $row) {
        	$l1string .= $row . "\n";
	}

	exec('/bin/cat /proc/l2_stats', $result2);
	foreach($result2 as $row2) {
		$l2string.= $row2 . "\n";
	}
	return('getisdnstats:success' . "\nLAYER1:\n" . $l1string . "\nLAYER2:\n" . $l1string);
}

function getisgwinfo() {

	$parm = _parse_data();

	if(count($parm) != 1) {
		return('getisgwinfo:failed:getisgwinfo_requires_1_parameter');
	}

	if ($parm['isgwcmd'] == '') {
		return('getisgwinfo:error');
	}

	$isgw = new isgwtelnet();
	if (!($result = $isgw->isgw_login())) {
		return('getisgwinfo:error');
	}

	return('getisgwinfo:success' ."\n" . $isgw->isgw_transparent($parm['isgwcmd']));
}

function reload() {
	$error = 0;
	$isgw = new isgwtelnet();

	if (!($result = $isgw->isgw_login())) {
		$error = 1;
	}

	if (!($result = $isgw->isgw_dialplanreload())) {
		$error = 1;
	}

	if (!($result = $isgw->isgw_sipreload())) {
		$error = 1;
	}

	if (!($result = $isgw->isgw_rcpt())) {
		$error = 1;
	}

	if (!($result = $isgw->isgw_rgc())) {
		$error = 1;
	}

	exec('/usr/local/init/S60cloud stop');
	exec('/usr/local/init/S60cloud start');
	exec('/usr/local/init/S80snmpd restart');
	exec('/usr/local/init/S55SMGW restart');
	exec('/etc/init.d/S91userapp restart');

	if ($error) {
		return('reload:error');
	}

	$ba = new beroAri();
	$ba->update('UPDATE activate SET option=0 WHERE option=1;');

	return('reload:success');
}

function restart() {
	$result = exec('/usr/local/init/S50isgw stop');
	$result = exec('/usr/local/init/S10li-setup stop');
	$result = exec('/usr/local/init/S10li-setup start');
	$result = exec('/usr/local/init/S50isgw start');

	if (!$result) {
		return('restart:error');
	}

	$ba = new beroAri();
	$ba->update('UPDATE activate SET option=0;');

	return('restart:success');
}

function reboot() {
	$bc = new beroConf('root');
	$bc->set('root', 'boot_fwupdate', '0');
	$result = exec('/sbin/reboot');
        return('reboot:rebooting....');
}

function rebootfirmwareupdate () {
	$bc = new beroConf('root');
	$bc->set('root', 'boot_fwupdate', '1');
	$result = exec('/sbin/reboot');
        return('reboot:update_mode');
}

function restoreoldconfig() {
	$result = exec('/usr/local/bin/update-tftp.sh restore');
	return($result);
}

function settftp() {

	$parm = _parse_data();

	if (count($parm) != 3) {
		return('settftp:failed:settftp_requires_3_parameters');
	}

	if (($parm['tftponboot'] != 'yes') && ($parm['tftponboot'] != 'no')) {
		return('settftp:failed:valid_values_for_tftponboot_are[yes|no]');
	}

	$bc = new beroConf('root');
	$bc->set('root', 'tftp-host',$parm['tftphost']);
	$bc->set('root', 'tftp-url', $parm['tftpurl']);
	$bc->set('root', 'use-boot-prov', $parm['tftponboot']);

	return('settftp:success');
}

function sethttp() {

	$parm = _parse_data();

	if (count($parm) < 3) {
		return('sethttp:failed:sethttp_requires_3_parameters');
	}

	if (($parm['httponboot'] != 'yes') && ($parm['httponboot'] != 'no')) {
		return('sethttp:failed:valid_values_for_httponboot_are[yes|no]');
	}

	$bc = new beroConf('root');
	$bc->set('root', 'http-host', $parm['httphost'] . ((!isset($parm['httpport'])) ? '' : ':' . $parm['httpport']));
	$bc->set('root', 'http-url', $parm['httpurl']);
	$bc->set('root', 'use-boot-prov', $parm['httponboot']);

	return('sethttp:success');
}

function logging() {

	$parm = _parse_data();

	if (count($parm) != 4) {
		return('logging:failed:logging_requires_at_least_4_parameters');
	}

	$isgw = new isgwtelnet();

	$isgw->isgw_login();
	usleep(500);

	$isgw->logserver($parm['logserver'], $parm['logport']);
	usleep(500);

	$isgw->loglevel_message($parm['loglevel']);
	usleep(500);

	$isgw->logactive_message($parm['active']);
	usleep(500);

	return('logging:success');
}

function createConfBackup () {

	$cb = new confBackup();

	$ret = $cb->createFullBackup();

	header('Content-Type: application/force-download');
	header('Content-Disposition: attachment; filename=' . $ret['name'] . "\r\n\r\n");
	header('Content-Length: ' . strlen($ret['file']) . "\n\n");

	return($ret['file']);
}

function restoreConfBackup () {

	$fileName = $_FILES['userfile']['name'];
	$tempFile = $_FILES['userfile']['tmp_name'];

	$cb = new confBackup();

	switch ($cb->verifyFileName($fileName)) {
	case 0:
		return('restoreconfbackup:failed:invalid_filename');
	case 1:
		$res = $cb->installConfFile($fileName, $tempFile);
		break;
	case 2:
	case 3:
		$res = $cb->installFullBackup($fileName, $tempFile);
		break;
	}

	if ($res == false) {
		return('restoreconfbackup:failed:' . $fileName);
	}

	Helper::activate(3);
	return('restoreconfbackup:success');
}

function setprovtype() {

	$parm = _parse_data();

	if (count($parm) != 1) {
		return('setprovtype:error:requires_1_parameter');
	}

	if (($parm['type'] != 'http') && ($parm['type'] != 'ftp')) {
		return('setprovtype:failed:valid_values_for_setprovtype_are[http|tftp]');
	}

	$bc = new beroConf('root');
	$bc->set('root', 'provisioning-option', $parm['type']);
	return('setprovtype:success');
}

function config_update() {

	$res = exec('/usr/local/bin/update-tftp.sh config', $out);
	foreach ($out as $str) {
		if (preg_match('/FAILURE:(.*)/', $str, $matches)) {
			$res.= "<br />\n" . $matches[1];
                }
	}

	return($res);;
}

function firmware_update_form() {

	include('/usr/php/include/updateTool.php');

	# check if we're in update-mode
	$bc = new beroConf('root');
	if ($bc->get('root', 'boot_fwupdate') != 1) {
		return('firmware_update_form:failed:not_in_update_mode');
	}

	$upd = new updateTool();

	# everything's allright, upload file
	$ret = $upd->upload($_FILES);
	if ($ret['message'] != false) {
		return ('firmware_update_form:' . (($ret['error'] == true) ? 'failed:' : 'warning:') . ' ' . $ret['message'] . "\n");
	}

	if (($ret['filename'] != false) && ($ret['error'] == false)) {
		$retval = $upd->install($ret['filename'], $false);
	}

        return('firmware_update_form:' . (($retval == false) ? 'failed' : 'success'));
}

function firmware_update() {
	$res = exec('/sbin/reboot');
	return('firmware_update:success');
#	return(exec('/usr/local/bin/update-tftp.sh firmware'));
}

function getinfo() {

	//RootFS-Version
	$f = @file('/VERSION');
	$tmp = split('=', $f[1]);
	$rootfs = trim($tmp[1], "\n");
	$resultstring = 'ROOTFSVersion:' . $rootfs . "\n";

	//AppFS-Version
	$bc = new beroConf('root');
	$appfs = $bc->get('root', 'app-image');
	$resultstring .= 'APPFSVersion:' . $appfs . "\n";

	// Hardware-Revision
	exec('/bin/cat /proc/cmdline', $res);
	preg_match('/.*revision=([0-9\.]*)/', $res[0], $hwrev);
	$resultstring .= 'HWRevision:' . $hwrev['1'] . "\n";

	// Serial-Number
	preg_match('/carduuid=([0-9\-]*)/', $res[0], $serial);
	$resultstring .= 'HWSerial:' . $serial['1'] . "\n";

	// MAC-Address
	exec('/sbin/ifconfig eth0 | /bin/grep HWaddr', $resm);
	preg_match('/[^a-zA-Z0-9:]*? HWaddr (?<mac>.+)/', $resm[0], $mac);
	$resultstring .= 'MAC:' . $mac['mac'] . "\n";

	// FPGA-Version
	$fpga = exec('/bin/cat /proc/FPGA_VERSION');
	$resultstring .= 'FPGAVersion:' . $fpga . "\n";

	// API-Version
	global $Version;
	$resultstring .= 'APIVersion:' . $Version . "\n";

	return $resultstring;
}

function getlif () {

	for ($i = 0; $i < 2; $i++) {

		exec('/bin/cat /proc/li' . $i, $res);
		preg_match('/type: (?<li>.+)/', $res[0], $lif);
		unset($res);

		if ($lif['li'] == 'unknown') {
			continue;
		}

		switch ($lif['li']) {
		case 'xhfc-1su':	$type = 'bf1S0';	break;
		case 'xhfc-2su':	$type = 'bf2S0';	break;
		case 'xhfc-4su':	$type = 'bf4S0';	break;
		case 'hfc-e1':		$type = 'bf1E1';	break;
		case 'hfc-2e1':		$type = 'bf2E1';	break;
		case 'xhfcSi-2s02fxs':	$type = 'bf2S02FXS';	break;
		case 'si-1fxs':		$type = 'bf1FXS';	break;
		case 'si-4fxs':		$type = 'bf4FXS';	break;
		case 'si-8fxs':		$type = 'bf8FXS';	break;
		case 'si-2fxo':		$type = 'bf2FXO';	break;
		case 'si-4fxo':		$type = 'bf4FXO';	break;
		case 'telit-1GSM':	$type = 'bf1GSM';	break;
		case 'telit-2GSM':	$type = 'bf2GSM';	break;
		case 'falc-1t1e1':	$type = 'bf1t1e1';	break;
		case 'falc-2t1e1':	$type = 'bf2t1e1';	break;
		case 'falc-4t1e1':	$type = 'bf4t1e1';	break;
		}

		$ret .= 'lif:' . $i . ';type:' . $type . "\n" ;
	}

	return($ret);
}

function berocloud() {

	$parm = _parse_data();

	if (count($parm) != 2) {
		return('berocloud:failed:cloud_requires_2_parameters');
	}

	if (($parm['cloud_enable'] != '1') && ($parm['cloud_enable'] != '0')) {
		return('berocloud:failed:valid_values_for_cloud_enable[1|0]');
	}

	$bc = new beroConf('root');
	$bc->set('root', 'cloud_enable', $parm['cloud_enable']);
	$bc->set('root', 'cloud_key', $parm['cloud_key']);

	return('berocloud:success');
}

function infocmd($sinfo) {

	$api_url = 'http://' . $_SERVER['HTTP_HOST'] . '/app/api/beroFix.php';
	$title = $sinfo;

	switch ($sinfo) {
	case 'setpassword':
		$helptext = 'Function to set the beroNet Gateway Password (GUI, API & SSH)';
		$usage = array('[command]=setpassword', '[key1]=oldpassword', '[value1]=[oldpassword]', '[key2]=newpassword', '[value2]=[newpassword]',
			'<a href="' . $api_url . '?cmd=setpassword&data=oldpassword=admin:newpassword=admin">Example: ' . $api_url .
			'?cmd=setpassword&data=oldpassword=admin:newpassword=admin</a>');
		$return = array('setpassword:success -> if everthing was ok.', 'setpassword:error -> if an error occured.');
		break;
	case 'smslist':
		$helptext = 'Function to list the SMS Queues.';
		$usage = array('[command]=smslist', '[key]=queue', '[value]=[queuename]',
				'Example: ' . $api_url  . '?cmd=smslist&data=queue=failout');
		$return = array('smslist:success -> if everthing was ok.', 'smslist:error -> if an error occured.');
		break;
	case 'smsget':
		$helptext = 'Function to retrieve a SMS.';
		$usage = array('[command]=smsget', '[key1]=queue', '[value1]=[queuename]', '[key2]=idx', '[value2]=[smsid]','[key3]=delete',
				'[value3]=[yes] <i>just if you want to delete the sms</i>',
				'Example: ' . $api_url  . '?cmd=smsget&data=queue=out:idx=000013fb09d06:delete=yes');
		$return = array('smsget:success -> if everthing was ok.', 'smsget:error -> if an error occured.');
		break;
	case 'smsdelete':
		$helptext = 'Function to delete a SMS.';
		$usage = array('[command]=smsdelete', '[key1]=queue', '[value1]=[queuename]', '[key2]=idx', '[value2]=[smsid]',
				'Example: ' . $api_url  . '?cmd=smsdelete&data=queue=out:idx=000013fb09d06');
		$return = array('smsdelete:success -> if everthing was ok.', 'smsdelete:error -> if an error occured.');
		break;
	case 'healthcheck':
		$helptext = 'Function to check the health state of the beroNet Gateway.';
		$usage = array('[command]=healthcheck', 'Example: ' . $api_url  . '?cmd=healthcheck');
		$return = array('CPU Load:[number]','Free RAM:[number]');
		break;
	case 'smssend':
		$helptext = 'Function to send a SMS.';
		$usage = array('[command]=smssend2', '[num]=[phonenumber] <i>HTML special characters have to be replaced</i>', '[port]=[portnumber]',
				'[msg]=[message] <i>HTML special characters have to be replaced</i>',
				'Example: ' . $api_url  . '?cmd=smssend&num=%2B123456&port=1&msg=This is the message');
		$return = array('smssend:success -> if everthing was ok.','smssend:error -> if an error occured.');
		break;
	case 'fulltrace':
		$helptext =	'Function start, stop and download a Fulltrace on the beroNet Gateway for support reasons.<br />\n' .
				'Download File (DebugFiles.tar.gz) to analyze with Wireshark.';
		$usage = array('[command]=fulltrace', '[key1]=action', '[value1]=[start|stop|download]', '[key2]=sipsig',
				'[value2]=[yes|no] <i>only set if action=start</i>', '[key3]=sipaudio', '[value3]=[yes|no] <i>only set if action=start</i>',
				'Examples:', '<a href="' . $api_url  . '?cmd=fulltrace&data=action=start:sipsig=yes:sipaudio=no">' .
				'Start: ' . $api_url . '?cmd=fulltrace&data=action=start:sipsig=yes:sipaudio=no</a>',
				'<a href="' . $api_url . '?cmd=fulltrace&data=action=stop">Stop: ' . $api_url . '?cmd=fulltrace&data=action=stop</a>',
				'<a href="' . $api_url . '?cmd=fulltrace&data=action=download">Download: ' . $api_url . '?cmd=fulltrace&data=action=download</a>');
		$return = array('fulltrace:success -> if everthing was ok.', 'fulltrace:error -> if an error occured.');
		break;
	case 'setprovtype':
		$helptext = 'Function to set the beroNet Gateway provisioning mode to tftp or http.';
		$usage = array('[command]=setprovtype', '[key]=type', '[value]=[tftp|http]', 'Example: ' . $api_url . '?cmd=setprovtype&data=type=tftp');
		$return = array('setprovtype:success -> if everthing was ok.', 'setprovtype:error -> if an error occured.');
		break;
	case 'settftp':
		$helptext = 'Function to set TFTP Server and URL.';
		$usage = array('[command]=settftp', '[key1]=tftphost', '[value1]=[tftphostIP]', '[key2]=tftpurl', '[value2]=[tftURL]', '[key3]=tftponboot',
				'[value3]=[yes|no]', 'Example: ' . $api_url . '?cmd=settftp&data=tftphost=10.0.0.1:tftpurl=berofix:tftponboot=no');
		$return = array('settftp:success -> if everthing was ok.","settftp:error -> if an error occured.');
		break;
	case 'sethttp':
		$helptext = 'Function to set HTTP Server and URL.';
		$usage = array('[command]=sethttp', '[key1]=httphost', '[value1]=[httphostIP]', '[key2]=httpurl', '[value2]=[httpurl]', '[key3]=httponboot',
			'[value3]=[yes|no]', '[key4]=httpport', '[value4]=[httpport]', 'Example: ' . $api_url .
			'?cmd=sethttp&data=httphost=10.0.0.1:httpport=81:httpurl=berofix:httponboot=no');
		$return = array('sethttp:success -> if everthing was ok.', 'sethttp:error -> if an error occured.');
		break;
	case 'setdhcp':
		$helptext = 'Function to set HTTP Server and URL.';
		$usage = array('[command]=setdhcp', 'Example: ' . $api_url . '?cmd=setdhcp');
		$return = array('setdhcp:success -> if everthing was ok.', 'setdhcp:error -> if an error occured.');
		break;
	case 'setnetwork':
		$helptext = 'Function to set the network settings.';
		$usage = array('[command]=setnetwork', '[key1]=ip', '[value1]=[IPAddress]', '[key2]=netmask', '[value2]=[netmask]', '[key3]=gateway',
				'[value3]=[gateway]', '[key4]=nameserver', '[value4]=[nameserver]',
				'Example: ' . $api_url . '?cmd=setnetwork&data=ip=168.12.0.110:netmask=255.255.0.0:gateway=168.12.0.1:nameserver=168.12.0.1');
		$return = array('setnetwork:success -> if everthing was ok.', 'setnetwork:error -> if an error occured.');
		break;
	case 'config_update':
		$helptext = 'Function to start Config Update via TFTP or HTTP depending on how setprovtype is set.';
		$usage = array('[command]=config_update', '<a href="' . $api_url  . '?cmd=config_update">Example: ' . $api_url . '?cmd=config_update</a>');
		$return = array('config_update:Prov_type:success -> if everthing was ok',
				'config_update:Prov_type:failed:[comments] ->TFTP / HTTP problem or no Download selected.[comments] for details',
				'config_update:Prov_type:error -> if an major error occured. Check Config Files.');
		break;
	case 'firmware_update':
		$helptext = 'Function to start Firmware update via TFTP or HTTP depending on how setprovtype is set.';
		$usage = array('[command]=firmware_update', 'Example: <a href="' . $api_url . '?cmd=firmware_update">' . $api_url . '?cmd=firmware_update</a>');
		$return = array('firmware_update:success -> if everything was ok<br /><br />',
				'This function is obsolete and will always return \'success\' as it just reboots the Gateway.',
				'Change your scripts to call <a href="' . $api_url . '?cmd=info&data=info=reboot">reboot</a>.<br /><br />',
				'This will reboot the Gateway which triggers firmware-updates by provisioning.');
		break;
	case 'rebootfirmwareupdate':
		$helptext =	'Function to reboot beroNet Gateway into Update-Mode.';
		$usage = array(	'[command]=rebootfirmwareupdate',
				'Example: <a href="' . $api_url . '?cmd=rebootfirmwareupdate">' . $api_url . '?cmd=rebootfirmwareupdate</a>');
		$return = array('reboot:update_mode -> if reboot into Update-Mode is initiated');
		break;
	case 'firmware_update_form':
		$helptext =	'Function to start Firmware-Update via web form.';
		$usage = array(	'[command]=firmware_update_form',
				'[userfile]=[firmware file]',
				'Example: <a href="' . $api_url . '?cmd=firmware_update_form">' . $api_url . '?cmd=firmware_update_form</a>',
				'This operation may take several minutes');
		$return = array('firmware_update_form:success -> if everthing was ok',
				'firmware_update_form:failed:not_in_update_mode -> run rebootfirmwareupdate first',
				'firmware_update_form:failed:[comments] -> problem with the uploaded file.[comments] for details');
		break;
	case 'getlif':
		$helptext = 'Function to retrieve currently installed LineInterfaces.';
		$usage = array('[command]=getlif', '<a href="' . $api_url . '?cmd=getlif">Example: ' . $api_url . '?cmd=getlif</a>');
		$return = array('lif:Lineinterface Number', 'type:Lineinterface type', 'lif:[0|1];type:[bf4S0|bf1E1|bf2E1|...]',
				'Example:', 'lif:0;type:bf2E1','lif:1;type:bf4S0');
		break;
	case 'getinfo':
		$helptext = 'Function to get information on Hardware-Revison, Firmware-Version, etc.';
		$usage = array('[command]=getinfo', '<a href="' . $api_url . '?cmd=getinfo">Example: ' . $api_url . '?cmd=getinfo</a>');
		$return = array('ROOTFSVersion:[number]', 'APPFSVersion:[number]', 'HWRevision:[number]', 'HWSerial:[number]', 'FPGAVersion:[number]',
				'MAC:[macaddress]', 'APIVersion:[version]');
		break;
	case 'reload':
		$helptext = 'Function to reload settings.';
		$usage = array('[command]=reload', '<a href="' . $api_url . '?cmd=reload">Example: ' . $api_url . '?cmd=reload</a>');
		$return = array('reload:success -> if everthing was ok', 'reload:error ->if an error occured');
		break;
	case 'getcdr':
		$helptext = 'Function to get the CDR.';
		$usage = array('[command]=getcdr', '[key1]=log', '[value1]=[yes|no]', '[key2]=action', '[value2]=download', 'Example: ' . $api_url .
				'?cmd=getcdr&data=log=yes', 'Example: ' . $api_url . '?cmd=getcdr&data=action=download');
		$return = array('getcdr:success -> if everthing was ok.', 'getcdr:error -> if an error occured.');
		break;
	case 'reboot':
		$helptext = 'Function to reboot beroNet Gateway.';
		$usage = array('[command]=reboot', '<a href="' . $api_url . '?cmd=reboot">Example: ' . $api_url . '?cmd=reboot</a>');
		$return = array('reboot:rebooting... -> if reboot is initiated');
		break;
	case 'createConfBackup':
		$helptext = 'Function to create and download Backup of beroNet Gateway Configuration-Files.';
		$usage = array('[command]=createConfBackup', '<a href="' . $api_url . '?cmd=createConfBackup">Example: ' . $api_url . '?cmd=createConfBackup</a>');
		$return = array('File \'beroNetGW-[SERIAL_OF_GATEWAY]-backup.tar.gz\' as file-download.');
		break;
	case 'restoreConfBackup':
		$helptext = 'Function to upload and install Backup of beroNet Gateway Configuration-Files.';
		$usage = array(	'[command]=restoreConfBackup',
				'[userfile]=[Configuration File]',
				'<a href="' . $api_url . '?cmd=restoreConfBackup">Example: ' . $api_url . '?cmd=restoreConfBackup</a>');
		$return = array('restoreConfBackup:success -> if everthing was ok.', 'restoreConfBackup:failed -> if an error occured.');
		break;
	case 'getisdnstate':
		$helptext = 'Function to get the state of each configured ISDN port.';
		$usage = array('[command]=getisdnstate', '<a href="' . $api_url . '?cmd=getisdnstate">Example: ' . $api_url . '?cmd=getisdnstate</a>');
		$return = array('getisdnstate:success -> if everthing was ok', 'getisdnstate:error -> if an error occured');
		break;
	case 'getisdnstats':
		$helptext = 'Function to get ISDN Layer1 / Layer 2 statistics.';
		$usage = array('[command]=getisdnstats', '<a href="' . $api_url . '?cmd=getisdnstats">Example: ' . $api_url . '?cmd=getisdnstats</a>');
		$return = array('getisdnstats:success -> if everthing was ok', 'getisdnstats:error -> if an error occured');
		break;
	case 'getanalogstate':
		$helptext = 'Function to get the state of each configured analog port.';
		$usage = array('[command]=getanalogstate', '<a href="' . $api_url . '?cmd=getanalogstate">Example: ' . $api_url . '?cmd=getanalogstate</a>');
		$return = array('getanalogstate:success -> if everthing was ok', 'getanalogstate:error -> if an error occured');
		break;
	case 'getsipstate':
		$helptext = 'Function to get the state of each SIP Registar.';
		$usage = array('[command]=getsipstate', '<a href="' . $api_url . '?cmd=getsipstate">Example: ' . $api_url . '?cmd=getsipstate</a>');
		$return = array('getsipstate:success -> if everthing was ok', 'getsipstate:error -> if an error occured');
		break;
	case 'restoreoldconfig':
		$helptext = 'Function to Restore the previous provisioning config.';
		$usage = array('[command]=restoreoldconfig', '<a href="' . $api_url . '?cmd=restoreoldconfig">Example: ' . $api_url . '?cmd=restoreoldconfig</a>');
		$return = array('restoreoldconfig:success -> if everthing was ok', 'restoreoldconfig:error -> if an error occured');
		break;
	case 'logging':
		$helptext = 'Function to logging capabilities on the beroNet Gateway.';
		$usage = array('[command]=logging', '[key1]=active', '[value1]=[0|1]', '[key2]=loglevel', '[value2]=[0-9]', '[key3]=logserver',
				'[value3]=[IP-Address]', '[key4]=logport', '[value4]=[udpport]',
				'<a href="' . $api_url . '?cmd=logging&data=active=1:loglevel=5:logserver=172.20.5.51:logport=55555">Example: ' .
				$api_url . '?cmd=logging&data=active=1:loglevel=5:logserver=172.20.5.51:logport=55555</a>');
		$return = array('logging:success -> if everthing was ok', 'logging:error -> if an error occured');
		break;
	case 'berocloud':
		$helptext = 'Function to enable Monitoring for beroNets Cloud solution';
		$usage = array('[command]=berocloud', '[key1]=cloud_enable', '[value1]=[0|1]', '[key2]=cloud_key', '[value2]=[CLOUDKEY]',
				'<a href="' . $api_url . '?cmd=berocloud&data=cloud_enable=1:cloud_key=5555555555">Example: ' .
				$api_url . '?cmd=berocloud&data=cloud_enable=0:cloud_key=5555555555</a>');
		$return = array('berocloud:success -> if everthing was ok', 'berocloud:error -> if an error occured');
		break;
	case 'getisgwinfo':
		$helptext = 'Function to get several ISGW Info Telnet Wrapper.';
		$usage = array('[command]=getisgwinfo', '[key]=isgwcmd', '[value]=[i|r|l|k|u|bc|ss|ssp|...]', 'i=isdn state', 'r=status of registration',
				'l=status of operation', 'k=status of operations (compact)', 'u=uptime of isgw', 'bc=list bchannel objects',
				'ss=show call statistics', 'ssp=show port specific call statistics',
				'or any other valid ISGW Telnet command. Press h in the', 'telnet interface to get a list of possible commands.',
				'<a href="' . $api_url . '?cmd=getisgwinfo&data=isgwcmd=u">Example: ' . $api_url . '?cmd=getisgwinfo&data=isgwcmd=u</a>');
		$return = array('getisgwinfo:success -> if everthing was ok', 'getisgwinfo:error -> if an error occured');
		break;
	}

	$dis  = '<br/><br/>' .
		'<table  class="contenttoc" width="90%"><tr><th colspan="2" style="text-align:left !important;">' . $title . '</th></tr>' .
		'<tr><td nowrap style="text-align:left !important;">' . $helptext . '</td></tr>' .
		'<tr><td style="text-align:left !important;">Usage:' . "\n" .
		'<ul style="padding:0px 15px;">' . "\n";
	foreach ($usage as $value){
			$dis .= '<li>' . $value . '</li>' . "\n";
	}
	$dis .= '</ul></td></tr>' .
		'<tr><td style="text-align:left !important;">Return values:' . "\n" .
		'<ul style="padding:0px 15px;">' . "\n";
	foreach ($return as $value){
		$dis .= '<li>' . $value . '</li>' . "\n";
	}
	$dis .= '</ul></td></tr></table><br/>' .
		'<a href="' . $api_url . '"><b><< back >></b></a>';

	return $dis;
}

?>
